@echo off

:: @ref http://stackoverflow.com/a/10052222 
:: @ref http://stackoverflow.com/a/620913

title Register Cygwin Filetypes

:: C:\cygwin\Cygwin.ico
set CYGWIN_SH_ICON=%SYSTEMROOT%\system32\shell32.dll,71
set CYGWIN_SH_CLASS=bashscript

:requireadmin

"%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system" >nul 2>&1 
if '%errorlevel%' NEQ '0' (
	echo Please run this file as Administrator.
	goto :done
)

:findtarget

set TARGET=not-found
if exist C:\Cygwin64\bin\mintty.exe (
	set TARGET=C:\Cygwin64\bin\mintty.exe
	goto :found
)
if exist C:\Cygwin64\bin\bash.exe (
	set TARGET=C:\Cygwin64\bin\bash.exe
	goto :found
)
if exist C:\bin\Cygwin64\bin\mintty.exe (
	set TARGET=C:\bin\Cygwin64\bin\mintty.exe
	goto :found
)
if exist C:\bin\Cygwin64\bin\bash.exe (
	set TARGET=C:\bin\Cygwin64\bin\bash.exe
	goto :found
)
if exist C:\Cygwin\bin\mintty.exe (
	set TARGET=C:\Cygwin\bin\mintty.exe
	goto :found
)
if exist C:\Cygwin\bin\bash.exe (
	set TARGET=C:\Cygwin\bin\bash.exe
	goto :found
)
if exist C:\bin\Cygwin\bin\mintty.exe (
	set TARGET=C:\bin\Cygwin\bin\mintty.exe
	goto :found
)
if exist C:\bin\Cygwin\bin\bash.exe (
	set TARGET=C:\bin\Cygwin\bin\bash.exe
	goto :found
)

:notfound

echo "Couldn't find cygwin bash, is it installed?"
goto :done

:found

echo Associating .sh with cygwin bash (%TARGET%)...

assoc .sh=%CYGWIN_SH_CLASS%

ftype %CYGWIN_SH_CLASS%=%TARGET% /bin/bash --login -i -c 'echo -ne "\e]0;Cygwin\a" ; cd "$(dirname "$(cygpath -u "%%1")")"; bash "$(cygpath -u "%%1")"'

reg add HKCR\%CYGWIN_SH_CLASS%\DefaultIcon /f /ve /t REG_SZ /d %CYGWIN_SH_ICON%

echo done.

:done

pause
